/*
 * Copyright (c) 2023 - 2024. KeyWare.Co.Ltd All rights reserved.
 * 项目名称：28所 C++ 信息安全性设计准则
 * 项目描述：用于检查C++源代码的安全性设计准则的Sonarqube插件
 * 版权说明：本软件属北京关键科技股份有限公司所有，在未获得北京关键科技股份有限公司正式授权情况下，任何企业和个人，不能获取、阅读、安装、传播本软件涉及的任何受知识产权保护的内容。
 */
package com.keyware.sonar.cxx;

import org.sonar.api.server.rule.RulesDefinition;

public class LogRuleRepository implements RulesDefinition {
    private static final String REPOSITORY_NAME = "SonarQube";

    @Override
    public void define(Context context) {
        // 创建规则仓库
        NewRepository repository = context.createRepository("log", LogLanguage.KEY)
                .setName(REPOSITORY_NAME);

        // 创建新规则

        NewRule errorRecoveryRule = repository.createRule("ParsingErrorRecovery");
        errorRecoveryRule.setName("Parsing Error Recovery");

        // 为另一个规则设置描述
        errorRecoveryRule.setHtmlDescription("<p>This rule checks for parsing error recovery issues</p>");

        // 完成规则创建
        repository.done();
    }
}
