#include <iostream>
#ifdef _WIN32
    #include <windows.h>
#else
    #include <dlfcn.h>
#endif

int test1()
{
    std::string a = "your_dll.dll";
    std::wstring wideDLLName(a.begin(), a.end());
//    std::string v = "aa";
//    std::wstring wideA(v.begin(),v.end());
//    if (wideDLLName == wideA) {
//        // 当 wideDLLName 等于 ANSI 字符串 "aa" 转换后的宽字符串时，这里的代码将被执行
//    }
    HINSTANCE hInst = LoadLibrary(wideDLLName.c_str());//error
    if (hInst == NULL) {
        std::cout << "无法加载库" << std::endl;
        return -1;
    }

    typedef void (*FuncType)();
    FuncType func = (FuncType)GetProcAddress(hInst, "实际函数名");
    if (func == NULL) {
        FreeLibrary(hInst);
        std::cout << "无法获取函数" << std::endl;
        return -1;
    }

    func();
    FreeLibrary(hInst);

    return 0;
}

#if !defined(_WIN32)
int test2()
{
    std::string b = "your_so_file.so";
//    if(b == ""){
//    }
    void *handle = dlopen(b.c_str(), RTLD_LAZY);//error
    if (!handle) {
        std::cerr << "无法打开库: " << dlerror() << '\n';
        return 1;
    }

    dlerror(); // 清除上一次调用产生的错误信息

    typedef void (*FuncType)();
    FuncType func = (FuncType)dlsym(handle, "实际函数名");
    const char *dlsym_error = dlerror();
    if (dlsym_error) {
        dlclose(handle);
        std::cerr << "无法加载符号 '实际函数名'：" << dlsym_error << '\n';
        return 1;
    }

    func();
    dlclose(handle);

    return 0;
}
#endif


int main()
{
    // 调用对应平台的函数
    #ifdef _WIN32
        test1();
    #else
        test2();
    #endif

    return 0;
}