package com.keyware.sonar;

import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.servlet.view.RedirectView;

@Controller
public class RedirectUrlChecker {

    @GetMapping("/old-url")
    public RedirectView redirectOldUrl(String url) { // Compliant，因为重定向的路径不是由方法传递进来的
        RedirectView redirectView = new RedirectView();
        redirectView.setUrl(url);// Noncompliant {{在重定向前对输入数据进行验证}}
        return redirectView;
    }

    @GetMapping("/old-url2")
    public String redirectOldUrl2() { // Compliant，因为重定向的路径不是由方法传递进来的
        // 302临时重定向到新的URL
        return "redirect:/new-url";
    }

    @GetMapping("/old-url3")
    public RedirectView redirectOldUrl3(String url) {
        RedirectView redirectView = new RedirectView(url); // Noncompliant {{在重定向前对输入数据进行验证}}
        redirectView.setUrl(url);  // Noncompliant {{在重定向前对输入数据进行验证}}
        return redirectView;
    }

    @GetMapping("/old-url4")
    public String redirectOldUrl4(String url) {
        // 302临时重定向到新的URL
        return "redirect:" + url; // Noncompliant {{在重定向前对输入数据进行验证}}
    }

    @GetMapping("/old-url5")
    public String redirectOldUrl5(String url) {
        // 302临时重定向到新的URL
        return url; // Noncompliant {{在重定向前对输入数据进行验证}}
    }

}